<?php

namespace App\Wrangler\Components;

use Illuminate\Http\Request;
use Medialight\Textstem\Models\Asset;
use Medialight\Textstem\Models\WranglerPage;
use Medialight\Textstem\Wrangler\ActiveComponent;
use Medialight\Textstem\Domain\Assets\Actions\SortAssetList;
/**
 * Class Sample
 *
 * A short summary of what this component does.
 *
 * @extends ActiveComponent
 */
class AssetDownloadList extends ActiveComponent
{
    public static string $description = 'Create a list of assets to download.';
    public static string $version = '1.0.0';

    public $config;

    public array $editSetup = [
        [
            'name' => 'template',
            'controltype' => 'select-template',
            'value' => 'default',
        ],
        [
            'name' => 'assets',
            'controltype' => 'asset_collection',
            'value' => '',
            'label' => 'Assets',
            'type' => 'file',
         ],
//        [
//            'name' => 'keyAsset',
//            'controltype' => 'asset_selector',
//            'value' => '',
//            'label' => 'keyAsset',
//        ],
    ];

    public function render(Request $request, WranglerPage $wranglerPage)
    {
        $view = $this->getView();
        $data = $this->data();
        $paths = $data['assets'] ?? [];
        //get asset instances sorted into the correct order
        $data['assets'] =  (new SortAssetList)($paths);
         return view($view, $data)->render();
    }

    public function preview()
    {
        $view = $this->getPreview();
        $data = $this->data();
        $paths = $data['assets'] ?? [];
        //get asset instances sorted into the correct order
        $data['assets'] =  (new SortAssetList)($paths);
        return view($view, $data)->render();
    }
}
